org.apache.commons.math3.random

## Class ISAACRandom

- java.lang.Object
- - org.apache.commons.math3.random.BitsStreamGenerator
  - - org.apache.commons.math3.random.ISAACRandom

All Implemented Interfaces:
  java.io.Serializable, RandomGenerator

    public class ISAACRandom
    extends BitsStreamGenerator
    implements java.io.Serializable

ISAAC: a fast cryptographic pseudo-random number generator
ISAAC (Indirection, Shift, Accumulate, Add, and Count) generates 32-bit random numbers. ISAAC has been designed to be cryptographically secure and is inspired by RC4. Cycles are guaranteed to be at least 240 values long, and they are 28295 values long on average. The results are uniformly distributed, unbiased, and unpredictable unless you know the seed.
This code is based (with minor changes and improvements) on the original implementation of the algorithm by Bob Jenkins.

Since:
  3.0
Version:
  $Id: ISAACRandom.java 1416643 2012-12-03 19:37:14Z tn $
See Also:
  Serialized Form

### Field Summary

Fields
`private int[]` `arr` Service variable.
`private int` `count` Count through the results in rsl[]
`private static int` `GLD_RATIO` The golden ratio
`private static int` `H_SIZE` Half-size of rsl[] and mem[]
`private int` `isaacA` Accumulator
`private int` `isaacB` The last result
`private int` `isaacC` Counter, guarantees cycle is at least 2^40
`private int` `isaacI` Service variable.
`private int` `isaacJ` Service variable.
`private int` `isaacX` Service variable.
`private static int` `MASK` For pseudo-random lookup
`private int[]` `mem` The internal state
`private int[]` `rsl` The results given to the user
`private static long` `serialVersionUID` Serializable version identifier
`private static int` `SIZE` Size of rsl[] and mem[]
`private static int` `SIZE_L` Log of size of rsl[] and mem[]

### Constructor Summary

Constructors
Constructor and Description
`ISAACRandom()` Creates a new ISAAC random number generator.
`ISAACRandom(int[] seed)` Creates a new ISAAC random number generator using an int array seed.
`ISAACRandom(long seed)` Creates a new ISAAC random number generator using a single long seed.

### Method Summary

Methods
`private void` `initState()` Initialize, or reinitialize, this instance of rand.
`private void` `isaac()` Generate 256 results
`private void` `isaac2()` Intermediate internal loop.
`private void` `isaac3()` Lowest level internal loop.
`protected int` `next(int bits)` Generate next pseudorandom number.
`void` `setSeed(int seed)` Sets the seed of the underlying random number generator using an `int` seed.
`void` `setSeed(int[] seed)` Sets the seed of the underlying random number generator using an `int` array seed.
`void` `setSeed(long seed)` Sets the seed of the underlying random number generator using a `long` seed.
`private void` `setState(int start)` Set the state by copying the internal arrays.
`private void` `shuffle()` Shuffle array.

### Methods inherited from class org.apache.commons.math3.random.BitsStreamGenerator

`clear, nextBoolean, nextBytes, nextDouble, nextFloat, nextGaussian, nextInt, nextInt, nextLong`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### serialVersionUID

    private static final long serialVersionUID

Serializable version identifier

See Also:
  Constant Field Values

#### SIZE_L

    private static final int SIZE_L

Log of size of rsl[] and mem[]

See Also:
  Constant Field Values

#### SIZE

    private static final int SIZE

Size of rsl[] and mem[]

See Also:
  Constant Field Values

#### H_SIZE

    private static final int H_SIZE

Half-size of rsl[] and mem[]

See Also:
  Constant Field Values

#### MASK

    private static final int MASK

For pseudo-random lookup

See Also:
  Constant Field Values

#### GLD_RATIO

    private static final int GLD_RATIO

The golden ratio

See Also:
  Constant Field Values

#### rsl

    private final int[] rsl

The results given to the user

#### mem

    private final int[] mem

The internal state

#### count

    private int count

Count through the results in rsl[]

#### isaacA

    private int isaacA

Accumulator

#### isaacB

    private int isaacB

The last result

#### isaacC

    private int isaacC

Counter, guarantees cycle is at least 2^40

#### arr

    private final int[] arr

Service variable.

#### isaacX

    private int isaacX

Service variable.

#### isaacI

    private int isaacI

Service variable.

#### isaacJ

    private int isaacJ

Service variable.

### Constructor Detail

#### ISAACRandom

    public ISAACRandom()

Creates a new ISAAC random number generator.
The instance is initialized using a combination of the current time and system hash code of the instance as the seed.

#### ISAACRandom

    public ISAACRandom(long seed)

Creates a new ISAAC random number generator using a single long seed.

Parameters:
  `seed` - Initial seed.

#### ISAACRandom

    public ISAACRandom(int[] seed)

Creates a new ISAAC random number generator using an int array seed.

Parameters:
  `seed` - Initial seed. If `null`, the seed will be related to the current time.

### Method Detail

#### setSeed

    public void setSeed(int seed)

Sets the seed of the underlying random number generator using an `int` seed.

Sequences of values generated starting with the same seeds should be identical.

Specified by:
  `setSeed` in interface `RandomGenerator`
Specified by:
  `setSeed` in class `BitsStreamGenerator`
Parameters:
  `seed` - the seed value

#### setSeed

    public void setSeed(long seed)

Sets the seed of the underlying random number generator using a `long` seed.

Sequences of values generated starting with the same seeds should be identical.

Specified by:
  `setSeed` in interface `RandomGenerator`
Specified by:
  `setSeed` in class `BitsStreamGenerator`
Parameters:
  `seed` - the seed value

#### setSeed

    public void setSeed(int[] seed)

Sets the seed of the underlying random number generator using an `int` array seed.

Sequences of values generated starting with the same seeds should be identical.

Specified by:
  `setSeed` in interface `RandomGenerator`
Specified by:
  `setSeed` in class `BitsStreamGenerator`
Parameters:
  `seed` - the seed value

#### next

    protected int next(int bits)

Generate next pseudorandom number.

This method is the core generation algorithm. It is used by all the public generation methods for the various primitive types `BitsStreamGenerator.nextBoolean()`, `BitsStreamGenerator.nextBytes(byte[])`, `BitsStreamGenerator.nextDouble()`, `BitsStreamGenerator.nextFloat()`, `BitsStreamGenerator.nextGaussian()`, `BitsStreamGenerator.nextInt()`, `BitsStreamGenerator.next(int)` and `BitsStreamGenerator.nextLong()`.

Specified by:
  `next` in class `BitsStreamGenerator`
Parameters:
  `bits` - number of random bits to produce
Returns:
  random bits generated

#### isaac

    private void isaac()

Generate 256 results

#### isaac2

    private void isaac2()

Intermediate internal loop.

#### isaac3

    private void isaac3()

Lowest level internal loop.

#### initState

    private void initState()

Initialize, or reinitialize, this instance of rand.

#### shuffle

    private void shuffle()

Shuffle array.

#### setState

    private void setState(int start)

Set the state by copying the internal arrays.

Parameters:
  `start` - First index into `mem` array.